/*:VRX         Main
*/
/*  Main
*/
Main:
/*  Process the arguments.
    Get the parent window.
*/
    parse source . calledAs .
    parent = ""
    argCount = arg()
    argOff = 0
    if( calledAs \= "COMMAND" )then do
        if argCount >= 1 then do
            parent = arg(1)
            argCount = argCount - 1
            argOff = 1
        end
    end; else do
        call VROptions 'ImplicitNames'
        call VROptions 'NoEchoQuit'
    end
    InitArgs.0 = argCount
    if( argCount > 0 )then do i = 1 to argCount
        InitArgs.i = arg( i + argOff )
    end
    drop calledAs argCount argOff

/*  Load the windows
*/
    call VRInit
    parse source . . spec
    _VREPrimaryWindowPath = ,
        VRParseFileName( spec, "dpn" ) || ".VRW"
    _VREPrimaryWindow = ,
        VRLoad( parent, _VREPrimaryWindowPath )
    drop parent spec
    if( _VREPrimaryWindow == "" )then do
        call VRMessage "", "Cannot load window:" VRError(), ,
            "Error!"
        _VREReturnValue = 32000
        signal _VRELeaveMain
    end

/*  Process events
*/
    call Init
    signal on halt
    do while( \ VRGet( _VREPrimaryWindow, "Shutdown" ) )
        _VREEvent = VREvent()
        interpret _VREEvent
    end
_VREHalt:
    _VREReturnValue = Fini()
    call VRDestroy _VREPrimaryWindow
_VRELeaveMain:
    call VRFini
exit _VREReturnValue

VRLoadSecondary:
    __vrlsWait = abbrev( 'WAIT', translate(arg(2)), 1 )
    if __vrlsWait then do
        call VRFlush
    end
    __vrlsHWnd = VRLoad( VRWindow(), VRWindowPath(), arg(1) )
    if __vrlsHWnd = '' then signal __vrlsDone
    if __vrlsWait \= 1 then signal __vrlsDone
    call VRSet __vrlsHWnd, 'WindowMode', 'Modal' 
    __vrlsTmp = __vrlsWindows.0
    if( DataType(__vrlsTmp) \= 'NUM' ) then do
        __vrlsTmp = 1
    end
    else do
        __vrlsTmp = __vrlsTmp + 1
    end
    __vrlsWindows.__vrlsTmp = VRWindow( __vrlsHWnd )
    __vrlsWindows.0 = __vrlsTmp
    do while( VRIsValidObject( VRWindow() ) = 1 )
        __vrlsEvent = VREvent()
        interpret __vrlsEvent
    end
    __vrlsTmp = __vrlsWindows.0
    __vrlsWindows.0 = __vrlsTmp - 1
    call VRWindow __vrlsWindows.__vrlsTmp 
    __vrlsHWnd = ''
__vrlsDone:
return __vrlsHWnd

/*:VRX         __VXREXX____APPENDS__
*/
__VXREXX____APPENDS__:
/*
*/
return
/*:VRX         CB_2PassEncode_Click
*/
CB_2PassEncode_Click: 
  set = VRGet( "CB_2PassEncode", "Set" )
  if set=1 then do
    ok = VRSet( "EF_ffmpegPar2", "Visible", 1 )
    ok = VRSet( "DT_14", "Visible", 1 )
  end
  else
  do
    ok = VRSet( "EF_ffmpegPar2", "Visible", 0 )
    ok = VRSet( "DT_14", "Visible", 0 )
  end
return

/*:VRX         CB_BurnISO_Click
*/
CB_BurnISO_Click: 
  call CheckChecked
return

/*:VRX         CB_Connect_Click
*/
CB_Connect_Click: 
  connectcheck = VRGet( "CB_Connect", "Set" )
  ok= VRSetIni("DVDVIDEO", "connectcheck", connectcheck, ActDir"\DVDBURN.INI" )
return

/*:VRX         CB_CreateISO_Click
*/
CB_CreateISO_Click: 
  call CheckChecked
return

/*:VRX         CB_CreateStructure_Click
*/
CB_CreateStructure_Click: 
  call CheckChecked
return

/*:VRX         CB_Pipe_Click
*/
CB_Pipe_Click: 
  pipecheck = VRGet( "CB_Pipe", "Set" )
  ok= VRSetIni("DVDVIDEO", "pipecheck", pipecheck, ActDir"\DVDBURN.INI" )
  if pipecheck = 1 then do
   ok=VRSet( "CB_Split", "Set", 0 )
   ok= VRSetIni("DVDVIDEO", "splitcheck", 0, ActDir"\DVDBURN.INI" )
  end
return

/*:VRX         CB_Split_Click
*/
CB_Split_Click: 
  splitcheck = VRGet( "CB_Split", "Set" )
  ok= VRSetIni("DVDVIDEO", "splitcheck", splitcheck, ActDir"\DVDBURN.INI" )
  if splitcheck = 1 then do
   ok=VRSet( "CB_Pipe", "Set", 0 )
   ok= VRSetIni("DVDVIDEO", "pipecheck", 0, ActDir"\DVDBURN.INI" )
  end
return

/*:VRX         CB_Transcode_Click
*/
CB_Transcode_Click: 
  call CheckChecked
return

/*:VRX         CheckChecked
*/
CheckChecked: 
  setTrans = VRGet( "CB_Transcode", "Set" )
  setStru = VRGet( "CB_CreateStructure", "Set" )
  setCrISO = VRGet( "CB_CreateISO", "Set" )
  setBrISO = VRGet( "CB_BurnISO", "Set" )
  if (setTrans=0) & (setStru=0) & (setCrISO=0) & (setBrISO=0) then
    ok = VRSet( "PB_Start", "Enabled", 0 )
  else do
    if (setTrans=1) | (setStru=1) then do
      if (VRGet( "LB_MPGFiles", "Count" )>0) then
        ok = VRSet( "PB_Start", "Enabled", 1 )
      else
        ok = VRSet( "PB_Start", "Enabled", 0 )
    end
    else
      ok = VRSet( "PB_Start", "Enabled", 1 )
  end
  if (setStru=1) | (setCrISO=1) | (setBrISO=1) then
    if (VRGet( "Combo_Name", "Value" )='') then
      ok = VRSet( "PB_Start", "Enabled", 0 )
  ok = VRSet( "CB_Connect", "Enabled", setStru )
  ok = VRSet( "CB_Split", "Enabled", setCrISO )
  ok = VRSet( "CB_Pipe", "Enabled", setBrISO )
return

/*:VRX         Combo_Name_Change
*/
Combo_Name_Change: 
  call CheckChecked
return

/*:VRX         CreateXML
*/
CreateXML: 
  parse arg aXMLFile aFolder
  ok = VRDeleteFile( aXMLFile )
  call LINEOUT aXMLFile, "<dvdauthor>"
  call LINEOUT aXMLFile, "    <vmgm />"
  call LINEOUT aXMLFile, "    <titleset>"
  call LINEOUT aXMLFile, "        <titles>"
  call LINEOUT aXMLFile, "            <pgc>"
  do n = 1 to count
    string = VRMethod( "LB_MPGFiles", "GetString", n )
    filepath = aFolder
    filename = VRParseFileName( string, "NE" )
    filepath = filepath'\'filename
    if n=1 then
      call LINEOUT aXMLFile, '             <vob file="'||filepath||'" chapters="0" />'
    else
      call LINEOUT aXMLFile, '             <vob file="'||filepath||'" />'
  end
  call LINEOUT aXMLFile, "            </pgc>"
  call LINEOUT aXMLFile, "        </titles>"
  call LINEOUT aXMLFile, "    </titleset>"
  call LINEOUT aXMLFile, "</dvdauthor>"
  call stream aXMLFile, 'c', 'close'
return

/*:VRX         Fini
*/
Fini:
    window = VRWindow()
    call VRSet window, "Visible", 0
    drop window
return 0

/*:VRX         Halt
*/
Halt:
    signal _VREHalt
return

/*:VRX         Init
*/
Init:
    window = VRWindow()
    call VRMethod window, "CenterWindow"
    call VRSet window, "Visible", 1
    call VRMethod window, "Activate"
    drop window
return

/*:VRX         MainWin_Close
*/
MainWin_Close:
    call Quit
return

/*:VRX         MainWin_Create
*/
MainWin_Create: 
  call rxfuncadd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
  call SysLoadFuncs
  CALL RxFuncAdd 'FileLoadFuncs', 'FILEREXX', 'FileLoadFuncs' 
  CALL FileLoadFuncs
  ok = VRRedirectStdIO( "On" )
  ActDir=VRCurrDir( VRCurrDrive() )
  ffmpegpath= VRGetIni("DVDVIDEO", "ffmpegpath", ActDir"\DVDBURN.INI", "NoClose" )
  ffmpegpar1= VRGetIni("DVDVIDEO", "ffmpegpar1", ActDir"\DVDBURN.INI", "NoClose" )
  ffmpegpar2= VRGetIni("DVDVIDEO", "ffmpegpar2", ActDir"\DVDBURN.INI", "NoClose" )
  ffmpegrate= VRGetIni("DVDVIDEO", "ffmpegrate", ActDir"\DVDBURN.INI", "NoClose" )
  ffmpegaurate= VRGetIni("DVDVIDEO", "ffmpegaurate", ActDir"\DVDBURN.INI", "NoClose" )
  ffmpeginterlace= VRGetIni("DVDVIDEO", "ffmpeginterlace", ActDir"\DVDBURN.INI", "NoClose" )
  ffmpegdeinterlace= VRGetIni("DVDVIDEO", "ffmpegdeinterlace", ActDir"\DVDBURN.INI", "NoClose" )
  ffmpeg2pass= VRGetIni("DVDVIDEO", "ffmpeg2pass", ActDir"\DVDBURN.INI", "NoClose" )
  dvdauthorpath= VRGetIni("DVDVIDEO", "dvdauthorpath", ActDir"\DVDBURN.INI", "NoClose" )
  dvdauthorparVOB= VRGetIni("DVDVIDEO", "dvdauthorparVOB", ActDir"\DVDBURN.INI", "NoClose" )
  dvdauthorparTOC= VRGetIni("DVDVIDEO", "dvdauthorparTOC", ActDir"\DVDBURN.INI", "NoClose" )
  mkisofs2path= VRGetIni("DVDVIDEO", "mkisofs2path", ActDir"\DVDBURN.INI", "NoClose" )
  mkisofs2par= VRGetIni("DVDVIDEO", "mkisofs2par", ActDir"\DVDBURN.INI", "NoClose" )
  dvddaopath= VRGetIni("DVDVIDEO", "dvddaopath", ActDir"\DVDBURN.INI", "NoClose" )
  dvddaopar= VRGetIni("DVDVIDEO", "dvddaopar", ActDir"\DVDBURN.INI", "NoClose" )
  dvddevice= VRGetIni("DVDVIDEO", "dvddevice", ActDir"\DVDBURN.INI", "NoClose" )
  structpath= VRGetIni("DVDVIDEO", "structpath", ActDir"\DVDBURN.INI", "NoClose" )
  connectcheck=VRGetIni("DVDVIDEO", "connectcheck", ActDir"\DVDBURN.INI" )
  splitcheck=VRGetIni("DVDVIDEO", "splitcheck", ActDir"\DVDBURN.INI" )
  pipecheck=VRGetIni("DVDVIDEO", "pipecheck", ActDir"\DVDBURN.INI" )
  ok = VRSet( "CB_Connect", "Set", connectcheck )
  ok = VRSet( "CB_Split", "Set", splitcheck )
  ok = VRSet( "CB_Pipe", "Set", pipecheck )
  call ReadFolders
  call SetLanguage
  call CheckChecked
return
/*:VRX         ParseOutput
*/
ParseOutput:
  parse arg aOutType, aMBComplete 
  ok = VRSet( "MainWin", "HintText", "Working, to cancel close the VIO program and wait 15 sec." )
  ok = VRSet( "SL_Progress", "Percentile", '0' )
  ok = VRSet( "DT_MBReady", "Caption", "" )
  ok = VRSet( "DT_MBAll", "Caption", "" )
  ok = VRSet( "DT_Text_MB", "Visible", 0 )

  ok = VRSet( "SL_Progress", "Visible", 1 )
  ok = VRSet( "DT_Percent", "Caption", '0'||'%' )
  breaked=0
  forcount=0
  
  DO forever
    call SysSleep 0.2    
    RLine=''
    IF QUEUED()\=0 THEN Do
      RLine = LINEIN("QUEUE:")      
      IF RLine='' THEN RLine=' '
      forcount = 0
    END
    if (pos("Info : Pausing 10 seconds",RLine) \= 0) then do
      forcount = forcount -10
    end
    if (pos("DONEACTION",RLine) \= 0) then do
      leave
    end

    if (aOutType = 'Trans') then do
      ok = VRSet( "DT_Text_MB", "Visible", 1 )
      ok = VRSet( "DT_MBAll", "Caption", Format(aMBComplete,,2) )
      /* if (pos("Lsize=",RLine) \= 0) then leave */
      if (pos("frame=",RLine) \= 0) then do
        posstart = pos('size=',RLine)+6
        posend = posstart+7
        kBready = strip(substr(RLine,posstart,posend-posstart),'L')
        if ffmpeg2pass = 1 then
          kBready = kBReady / 2
        kBDisplay = kBCum + kBready
        MBDisplay = Format((kBDisplay / 1024),,2)
        if MBDisplay > 0 then
          Percent = Format(((MBDisplay / aMBComplete) * 100),,0)
        ok = VRSet( "DT_MBReady", "Caption", MBDisplay )
        ok = VRSet( "SL_Progress", "Percentile", Percent )
        ok = VRSet( "DT_Percent", "Caption", Percent||'%' )
      end
    end
  
    if (aOutType = 'VTS') then do
      ok = VRSet( "DT_Text_MB", "Visible", 1 )
      ok = VRSet( "DT_MBAll", "Caption", Format(aMBComplete,,2) )
      if (pos("STAT: fixed",RLine) <> 0) then leave
      if (pos("STAT:",RLine) <> 0) & (pos("VOBU",RLine) <> 0) & (pos("fixed",RLine) = 0) then do
        posstart = pos('at',RLine)+3
        posend = pos('MB', RLine)+1
        MBready = substr(RLine,posstart,posend-posstart-1)
        pospercent = pos("%",RLine)
        if (pospercent <> 0) & (pos("100%",RLine) = 0) then do
          opcaption = VRGet( "DT_Operation", "Caption" )
          if opcaption <> "Fix VOBUS" then call VRSet "DT_Operation", "Caption", "Fix VOBUS"
          tempstr = substr(RLine,pospercent-3,3)
          posstart= pos(" ",tempstr)
          Percent = substr(tempstr,posstart,3)
          Percent = Percent / 2 + 50
        end
        else do
          if opcaption <> "Check VOBUS" then do
            call VRSet "DT_Operation", "Caption", "Check VOBUS"
            Percent = Format(MBReady / MBComplete * 100 / 2,,0)
          end
        end
        ok = VRSet( "DT_MBReady", "Caption", MBReady )
        ok = VRSet( "SL_Progress", "Percentile", Percent )
        ok = VRSet( "DT_Percent", "Caption", Percent||'%' )
      end
    end

    if (aOutType = 'TOC') then do
      ok = VRSet( "DT_Text_MB", "Visible", 0 )
    end

    if (aOutType = 'MakeImg') then do
      ok = VRSet( "DT_Text_MB", "Visible", 0 )
      if (pos("extents written",RLine) <> 0) then leave
      if (pos("estimate finish",RLine) <> 0) then do
        Percent = substr(RLine,2,2)
        ok = VRSet( "SL_Progress", "Percentile", Percent )
        ok = VRSet( "DT_Percent", "Caption", Percent||'%' )
      end
    end

    if (aOutType = 'Burn') then do
      ok = VRSet( "DT_Text_MB", "Visible", 1 )
      ok = VRSet( "DT_Text_MB", "Caption", "MB of" )
      if (pos("Info : Unlocking media...",RLine) <> 0) then leave        
      if (pos("Error :",RLine) <> 0) & (pos("Buffer underrun",RLine) = 0) then do
        error = 1
        leave        
      end
      if (pos("Info : Writing:",RLine) <> 0) then do
        posstart = pos("Writing:",RLine)+9
        posend = pos("MB of",RLine)
        MBready = substr(RLine,posstart,posend-posstart-1)
        posstart = pos('MB of',RLine)+6
        posend = pos('MB done',RLine)
        MBAll = substr(RLine,posstart,posend-posstart-1)
        pospercent = pos("%",RLine)
        tempstr = substr(RLine,pospercent-3,3)
        posstart= pos("(",tempstr)
        Percent = substr(tempstr,posstart+1,3)
        ok = VRSet( "DT_MBReady", "Caption", MBReady )
        ok = VRSet( "DT_MBAll", "Caption", MBAll )
        ok = VRSet( "SL_Progress", "Percentile", Percent )
        ok = VRSet( "DT_Percent", "Caption", Percent||'%' )
      end
    end
    call LINEOUT logfile, RLine

    if (aOutType = 'Pipe') then do
      ok = VRSet( "DT_Text_MB", "Visible", 1 )
      ok = VRSet( "DT_Text_MB", "Caption", "MB done" )
      ok = VRSet( "SL_Progress", "Visible", 0 )
      ok = VRSet( "DT_Percent", "Visible", 0 )
      if (pos("Info : Unlocking media...",RLine) <> 0) then leave        
      if (pos("Info : Writing:",RLine) <> 0) then do
        posstart = pos("Writing:",RLine)+9
        posend = pos("MB done",RLine)
        MBready = substr(RLine,posstart,posend-posstart-1)
        ok = VRSet( "DT_MBReady", "Caption", MBReady )
      end
    end
    call LINEOUT logfile, RLine

    if (aOutType = 'Log') then call LINEOUT logfile, RLine

    if (queued() = 0) then do
      call SysSleep(1)
      forcount=forcount+1
      if (forcount > 15) then do
        breaked=1
        leave
      end
    end

  end
  call stream logfile, 'c', 'close'

  ok = VRSet( "DT_Operation", "Caption", "" )
  hinttext = VRGet( "MainWin", "HintText" )
  ok = VRSet( "MainWin", "HintText", "Ready." )

return

/*:VRX         PB_Add_Click
*/
PB_Add_Click: 
  ok = VRFileDialog( VRWindow(), "Choose MPEG file", "Open", "", "", , , "files." )
  i=0
  do files.0 
    i=i+1
    bExists = VRFileExists( files.i )
    if bExists==1 then
    position = VRMethod( "LB_MPGFiles", "AddString", files.i,  )
  end
  call CheckChecked
return

/*:VRX         PB_dvdauthorpathsel_Click
*/
PB_dvdauthorpathsel_Click: 
  sFile = VRGet( "EF_dvdauthorpath", "Value" )
  sInitialPath = VRParseFilePath( sFile, "DP" )||"\"
  sFile = VRFileDialog( VRWindow(), "Choose DVDAuthor executable", "Open", sInitialPath, "", ,  )
  bExists = VRFileExists( sFile )
  if bExists==1 then
    ok = VRSet( "EF_dvdauthorpath", "Value", sFile )
return

/*:VRX         PB_dvddaopathsel_Click
*/
PB_dvddaopathsel_Click: 
  sFile = VRGet( "EF_dvddaopath", "Value" )
  sInitialPath = VRParseFilePath( sFile, "DP" )||"\"
  sFile = VRFileDialog( VRWindow(), "Choose dvddao executable", "Open", sInitialPath, "", ,  )
  bExists = VRFileExists( sFile )
  if bExists==1 then
    ok = VRSet( "EF_dvddaopath", "Value", sFile )
return

/*:VRX         PB_ffmpegpathsel_Click
*/
PB_ffmpegpathsel_Click: 
  sFile = VRGet( "EF_ffmpegpath", "Value" )
  sInitialPath = VRParseFilePath( sFile, "DP" )||"\"
  sFile = VRFileDialog( VRWindow(), "Choose ffmpeg executable", "Open", sInitialPath, "", ,  )
  bExists = VRFileExists( sFile )
  if bExists==1 then
    ok = VRSet( "EF_ffmpegpath", "Value", sFile )
return

/*:VRX         PB_mkisofs2pathsel_Click
*/
PB_mkisofs2pathsel_Click: 
  sFile = VRGet( "EF_mkisofs2path", "Value" )
  sInitialPath = VRParseFilePath( sFile, "DP" )||"\"
  sFile = VRFileDialog( VRWindow(), "Choose mkisofs2 executable", "Open", sInitialPath, "", ,  )
  bExists = VRFileExists( sFile )
  if bExists==1 then
    ok = VRSet( "EF_mkisofs2path", "Value", sFile )
return

/*:VRX         PB_Remove_Click
*/
PB_Remove_Click: 
  selected = VRGet( "LB_MPGFiles", "Selected" )
  ok = VRMethod( "LB_MPGFiles", "Delete", selected )
  call CheckChecked
return

/*:VRX         PB_Settings_Click
*/
PB_Settings_Click: 
    ok= VRLoadSecondary( "SETTINGS" )
    ok= VRMethod( "SETTINGS", "Activate" ) 
return

/*:VRX         PB_SettingsCancel_Click
*/
PB_SettingsCancel_Click: 
  call SETTINGS_Fini
return

/*:VRX         PB_SettingsOK_Click
*/
PB_SettingsOK_Click: 
    ffmpegpath= VRGet( "EF_ffmpegpath", "Value" )
    ffmpegpar1= VRGet( "EF_ffmpegPar1", "Value" )
    ffmpegpar2= VRGet( "EF_ffmpegPar2", "Value" )
    ffmpegrate= VRGet( "EF_bitrate", "Value" )
    ffmpegaurate= VRGet( "EF_aurate", "Value" )
    ffmpeginterlace= VRGet( "CB_Interlace", "Set" ) 
    ffmpegdeinterlace= VRGet( "CB_Deinterlace", "Set" )
    ffmpeg2pass= VRGet( "CB_2PassEncode", "Set" )
    dvdauthorpath= VRGet( "EF_dvdauthorpath", "Value" )
    dvdauthorparVOB= VRGet( "EF_dvdauthorParVOB", "Value" )
    dvdauthorparTOC= VRGet( "EF_dvdauthorParTOC", "Value" )
    mkisofs2path= VRGet( "EF_mkisofs2path", "Value" )
    mkisofs2par= VRGet( "EF_mkisofs2Par", "Value" )
    dvddaopar= VRGet( "EF_dvddaoPar", "Value" )
    dvddevice= VRGet( "EF_dvddevice", "Value" )
    structpath= VRGet( "EF_structurepath", "Value" )
    ok= VRSetIni("DVDVIDEO", "ffmpegpath", ffmpegpath, ActDir"\DVDBURN.INI", "NoClose" )
    ok= VRSetIni("DVDVIDEO", "ffmpegpar1", ffmpegpar1, ActDir"\DVDBURN.INI", "NoClose" )
    ok= VRSetIni("DVDVIDEO", "ffmpegpar2", ffmpegpar2, ActDir"\DVDBURN.INI", "NoClose" )
    ok= VRSetIni("DVDVIDEO", "ffmpegrate", ffmpegrate, ActDir"\DVDBURN.INI", "NoClose" )    
    ok= VRSetIni("DVDVIDEO", "ffmpegaurate", ffmpegaurate, ActDir"\DVDBURN.INI", "NoClose" )
    ok= VRSetIni("DVDVIDEO", "ffmpeginterlace", ffmpeginterlace, ActDir"\DVDBURN.INI", "NoClose" )
    ok= VRSetIni("DVDVIDEO", "ffmpegdeinterlace", ffmpegdeinterlace, ActDir"\DVDBURN.INI", "NoClose" )
    ok= VRSetIni("DVDVIDEO", "ffmpeg2pass", ffmpeg2pass, ActDir"\DVDBURN.INI", "NoClose" )
    ok= VRSetIni("DVDVIDEO", "dvdauthorpath", dvdauthorpath, ActDir"\DVDBURN.INI", "NoClose" )
    ok= VRSetIni("DVDVIDEO", "dvdauthorparVOB", dvdauthorparVOB, ActDir"\DVDBURN.INI", "NoClose" )
    ok= VRSetIni("DVDVIDEO", "dvdauthorparTOC", dvdauthorparTOC, ActDir"\DVDBURN.INI", "NoClose" )
    ok= VRSetIni("DVDVIDEO", "mkisofs2path", mkisofs2path, ActDir"\DVDBURN.INI", "NoClose" )
    ok= VRSetIni("DVDVIDEO", "mkisofs2par", mkisofs2par, ActDir"\DVDBURN.INI", "NoClose" )
    ok= VRSetIni("DVDVIDEO", "dvddaopath", dvddaopath, ActDir"\DVDBURN.INI", "NoClose" )
    ok= VRSetIni("DVDVIDEO", "dvddaopar", dvddaopar, ActDir"\DVDBURN.INI", "NoClose" )
    ok= VRSetIni("DVDVIDEO", "dvddevice", dvddevice, ActDir"\DVDBURN.INI", "NoClose" )
    ok= VRSetIni("DVDVIDEO", "structpath", structpath, ActDir"\DVDBURN.INI" )
    call ReadFolders
    call SETTINGS_Fini
return

/*:VRX         PB_Start_Click
*/
PB_Start_Click:
error=0
qname="DVDBURNQ"
call RXQueue 'Create',qname
oldq=RXQUEUE('Set',qname)
/* Clean queue */
DO WHILE QUEUED()\=0
	PULL str
END
'RXQUEUE 'qname' /CLEAR'

ok = VRSet( "PB_Start", "Enabled", 0 )
ok = VRSet( "PB_Settings", "Enabled", 0 )
ok = VRSet( "PB_Add", "Enabled", 0 )
ok = VRSet( "PB_Remove", "Enabled", 0 )
ok = VRSet( "DT_Operation", "Caption", "" )

position = VRMethod( "LB_Output", "AddString", "Operations starts...",  )
ffmpegfolder = VRParseFilePath( ffmpegpath, "DP" )
dvdauthorfolder = VRParseFilePath( dvdauthorpath, "DP" )
nPosLastBS = lastpos('\',structpath )
length  = Length( structpath )
if length != nPosLastBS then
  structpath = structpath||'\'
DVDName = VRGet( "Combo_Name", Value )
logfile=structpath||DVDName||'_log.txt'
position = VRMethod( "LB_Output", "AddString", "Logfile is "||logfile,  )
call SysMkDir structpath||DVDName
count = VRGet( "LB_MPGFiles", "Count" )

MBComplete = 0
kBCum = 0
do n = 1 to count
  string = VRMethod( "LB_MPGFiles", "GetString", n )
  handle = FileOpen(string, 'r', 'e', 0)
  err = FileGetInfo(handle, 'fileinfo', 'SIZE')      
  MBComplete = MBComplete + ((fileinfo.0) / 1048576)
end

echo 'log for creating '||DVDName||' > ' ||logfile
set = VRGet( "CB_Transcode", "Set" )
if set = 1 then do
  ok = VRSet( "CB_Transcode", "Enabled", 0 )
  ok = VRSet( "DT_Operation", "Caption", "Written:" )
  do n = 1 to count
    string = VRMethod( "LB_MPGFiles", "GetString", n )
    filename = VRParseFileName( string, "NE" )
    newfile = (VRParseFileName( string, "N" ))||'.MPG'
    ok = VRSet( "DT_Operation", "Caption", "Transcoded" )
    neudir = directory(ffmpegfolder)
    launch=ffmpegpath ' -i ' string ' -target dvd'
    if ffmpeg2pass = 1 then do
      position = VRMethod( "LB_Output", "AddString", "Transcoding "||filename||" pass 1",  )
      launch = launch ' -pass 1'   
    end
    else
      position = VRMethod( "LB_Output", "AddString", "Transcoding "||filename,  )
    if ffmpeginterlace = 1 then
      launch = launch ' -ildct -ilme'
    if ffmpegdeintlace = 1 then
      launch = launch ' -deinterlace'
    launch = launch ' -b ' ffmpegrate ' -ab ' ffmpegaurate ' ' ffmpegpar1 ' ' structpath'\'newfile||' 2>&1 |RXQUEUE '||qname||' /FIFO & ECHO DONEACTION 2>&1 |RXQUEUE '||qname||' /FIFO'
    launch='"'launch'"'
    echo launch '>> '|| logfile
    '@start "Transcode MPEG file p1" /C /B /MIN 'launch
    call ParseOutput 'Trans', MBComplete
    kBCum = kBCum + kBReady

    if breaked=1 then do
      call PB_Start_End
      return
    end

    if ffmpeg2pass = 1 then do                  /* second pass */
      position = VRMethod( "LB_Output", "AddString", "Transcoding "||filename||" pass 2",  )
      ok = VRSet( "DT_Operation", "Caption", "Transcoded" )
      launch=ffmpegpath ' -i ' string ' -target dvd -pass 2'
      if ffmpeginterlace = 1 then
        launch = launch ' -ildct -ilme'
      if ffmpegdeintlace = 1 then
        launch = launch ' -deinterlace'
      launch = launch ' -b ' ffmpegrate ' -ab ' ffmpegaurate ' ' ffmpegpar2 ' ' structpath'\'newfile||' 2>&1 |RXQUEUE '||qname||' /FIFO & ECHO DONEACTION 2>&1 |RXQUEUE '||qname||' /FIFO'
      launch='"'launch'"'
      echo launch '>> '|| logfile
      '@start "Transcode MPEG file p2" /C /B /MIN 'launch
      call ParseOutput 'Trans', MBComplete
      kBCum = kBCum + kBReady

      if breaked=1 then do
        call PB_Start_End
        return
      end

    end
  end
end
set = VRGet( "CB_CreateStructure", "Set" )
if set = 1 then do 
  ok = VRSet( "CB_CreateStructure", "Enabled", 0 )
  ok = VRSet( "CB_Connect", "Enabled", 0 )
  neudir = directory(dvdauthorfolder)
  connect = VRGet( "CB_Connect", "Set" )
  if connect = 1 then do
    position = VRMethod( "LB_Output", "AddString", "Creating VOB file(s)..."  )
    XMLfile = structpath||DVDName||'.XML'
    call CreateXML XMLfile structpath
    launch=dvdauthorpath ' -o ' structpath||DVDName||' -x '||XMLFile||' '||dvdauthorparVOB||' 2>&1 |RXQUEUE '||qname||' /FIFO & ECHO DONEACTION 2>&1 |RXQUEUE '||qname||' /FIFO'
    launch='"'launch'"'
    echo launch '>> '|| logfile
    '@start "Create VOBs with dvdauthor" /C /B /MIN 'launch
    call ParseOutput 'VTS', MBComplete

    if breaked=1 then do
      call PB_Start_End
      return
    end

  end
  else do  
    do n = 1 to count 
      string = VRMethod( "LB_MPGFiles", "GetString", n )
      filename = VRParseFileName( string, "NE" )
      position = VRMethod( "LB_Output", "AddString", "Creating VOB file for "||filename,  )
      neudir = directory(dvdauthorfolder)
      launch=dvdauthorpath ' -o ' structpath||DVDName||' '||dvdauthorparVOB||' '||structpath'\'filename||' 2>&1 |RXQUEUE '||qname||' /FIFO & ECHO DONEACTION 2>&1 |RXQUEUE '||qname||' /FIFO'
      launch='"'launch'"'
      echo launch '>> '|| logfile
      '@start "Create VOB with dvdauthor" /C /B /MIN 'launch
      call ParseOutput 'VTS', MBComplete

      if breaked=1 then do
        call PB_Start_End
        return
      end

    end
  end

  position = VRMethod( "LB_Output", "AddString", "Creating DVD structure",  )
  launch = dvdauthorpath ' -T -o '||dvdauthorparTOC||' '||structpath||DVDName||' 2>&1 |RXQUEUE '||qname||' /FIFO & ECHO DONEACTION 2>&1 |RXQUEUE '||qname||' /FIFO'
  launch='"'launch'"'
  echo launch '>> '|| logfile
  '@start "Create TOC with dvdauthor" /C /B /MIN 'launch
  call ParseOutput 'TOC'
end
neudir = directory(structpath||DVDName||"\VIDEO_TS")
ok = VRFileExists( "VIDEO_TS.IFO" )
if ok != 0 then do
  ok  = Beep( "200", "250" )
  position = VRMethod( "LB_Output", "AddString", "Error in DVD structure, no IFO file, see log",  )
  error=1
end
else do
  set = VRGet( "CB_CreateISO", "Set" )
  setSplit = VRGet( "CB_Split", "Set" ) 
  setPipe = VRGet( "CB_Pipe", "Set" ) 
  ok = VRSet( "CB_Split", "Enabled", 0 )
  if set = 1 then do
    ok = VRSet( "CB_CreateISO", "Enabled", 0 )
    ok = VRSet( "DT_Operation", "Caption", "Writing image..." )
    neudir = directory(structpath||DVDName)
    if setPipe = 1 then
      position = VRMethod( "LB_Output", "AddString", "Pipe image data to dvddao",  )
    else
      position = VRMethod( "LB_Output", "AddString", "Creating ISO-Image file(s)",  )
    if setSplit = 1 then
      launch=mkisofs2path '-dvd-video -o dvdimage '||mkisofs2par||' -v -split-output -r . 2>&1 |RXQUEUE '||qname||' /FIFO & ECHO DONEACTION 2>&1 |RXQUEUE '||qname||' /FIFO'
    else
    if setPipe = 1 then
      launch=mkisofs2path '2>nul -quiet -dvd-video '||mkisofs2par||' -v -r . |'||dvddaopath '--device '||dvddevice||' --eject '||dvddaopar||' - 2>&1 |RXQUEUE '||qname||' /FIFO & ECHO DONEACTION 2>&1 |RXQUEUE '||qname||' /FIFO'
    else
      launch=mkisofs2path '-dvd-video -o dvdimage '||mkisofs2par||' -v -r . 2>&1 |RXQUEUE '||qname||' /FIFO & ECHO DONEACTION 2>&1 |RXQUEUE '||qname||' /FIFO'
    launch='"'launch'"'
    echo launch '>> '|| logfile
    if setPipe =1 then do
      '@start "Pipe image direct to dvddao without file" /C /B /MIN 'launch
      call ParseOutput 'Pipe'
    end
    else do
      '@start "Create image with mkisofs2" /C /B /MIN 'launch
      call ParseOutput 'MakeImg'
    end

    if breaked=1 then do
      call PB_Start_End
      return
    end

  end
  set = VRGet( "CB_BurnISO", "Set" )
  setPipe = VRGet( "CB_Pipe", "Set" ) 
  if (set = 1) & (setPipe = 0) then do
    ok = VRSet( "CB_BurnISO", "Enabled", 0 )
    ok = VRSet( "DT_Operation", "Caption", "Written to DVD:" )
    neudir = directory(structpath||DVDName)
    if setSplit = 1 then do
      position = VRMethod( "LB_Output", "AddString", "Burning ISO-Image file(s)",  )
      fc=0
      do while VRFileExists( "dvdimage_0"||fc ) = 1
        if fc=0 then
          imglist = "dvdimage_0"||fc
        else
          imglist = imglist" dvdimage_0"||fc
        fc = fc+1
      end
      if fc=1 then do
        error=1
        position = VRMethod( "LB_Output", "AddString", "No Image file found !",  )
      end  
      launch=dvddaopath '--device '||dvddevice||' --eject '||dvddaopar||' '||imglist||' 2>&1 |RXQUEUE '||qname||' /FIFO & ECHO DONEACTION 2>&1 |RXQUEUE '||qname||' /FIFO'
      launch='"'launch'"'
      echo launch '>> '|| logfile
      '@start "Burn DVD with dvddao" /C /B /MIN 'launch
      call ParseOutput 'Burn'

      if breaked=1 then do
        call PB_Start_End
        return
      end

    end
    else do
      position = VRMethod( "LB_Output", "AddString", "Burning ISO-Image file",  )
      if VRFileExists( "dvdimage" ) = 1 then do
        launch=dvddaopath '--device '||dvddevice||' --eject '||dvddaopar||' '||dvdimage||' 2>&1 |RXQUEUE '||qname||' /FIFO & ECHO DONEACTION 2>&1 |RXQUEUE '||qname||' /FIFO'
        launch='"'launch'"'
        echo launch '>> '|| logfile
        '@start "Burn DVD with dvddao" /C /B /MIN 'launch
        call ParseOutput 'Burn'

        if breaked=1 then do
          call PB_Start_End
          return
        end

      end
      else do
        position = VRMethod( "LB_Output", "AddString", "Image file not found !",  )
        error = 1
      end
    end
  end
end
call PB_Start_End
return

PB_Start_End:
/* Clean queue */
DO WHILE QUEUED()\=0
  PULL str
END
'RXQUEUE 'qname' /CLEAR'
oldq=RXQUEUE('Set',oldq)  

if breaked=1 then
  position = VRMethod( "LB_Output", "AddString", "Break by timeout or user has canceled.", )
else
  if error=0 then
    position = VRMethod( "LB_Output", "AddString", "Finished.",  )
  else
    position = VRMethod( "LB_Output", "AddString", "Error(s) occured.",  )

ok = VRSet( "PB_Start", "Enabled", 1 )
ok = VRSet( "PB_Settings", "Enabled", 1 )
ok = VRSet( "PB_Add", "Enabled", 1 )
ok = VRSet( "PB_Remove", "Enabled", 1 )
ok = VRSet( "CB_Transcode", "Enabled", 1 )
ok = VRSet( "CB_CreateStructure", "Enabled", 1 )
ok = VRSet( "CB_CreateISO", "Enabled", 1 )
ok = VRSet( "CB_BurnISO", "Enabled", 1 )
ok = VRSet( "CB_Connect", "Enabled", 1 )
ok = VRSet( "CB_Split", "Enabled", 1 )
return
/*:VRX         PB_structurepathsel_Click
*/
PB_structurepathsel_Click: 
  sFile = VRGet( "EF_structurepath", "Value" )
  sInitialPath = VRParseFilePath( sFile, "DP" )||"\"
  sFile = DirDialg( VRWindow(), "Choose structure root path", sInitialPath )
  ok = VRSet( "EF_structurepath", "Value", sFile )
return

/*:VRX         Quit
*/
Quit:
    window = VRWindow()
    call VRSet window, "Shutdown", 1
    drop window
return

/*:VRX         ReadFolders
*/
ReadFolders: 
  rc = SysFileTree(structpath'*', folders, 'DO') 
  i=1
  do folders.0
    lbs = lastpos("\",folders.i)
    folders.i = strip(substr(folders.i,lbs+1,11))
    i=i+1
  end
  status = VRMethod( "Combo_Name", "AddStringList", "folders." )
return

/*:VRX         ReadSetup
*/
ReadSetup: 
 SetupDatei = ARG(1)
 i = 0
 do while lines(SetupDatei) <> 0
  i = i+1
  Zeile = linein(SetupDatei)
  j = pos('=',Zeile)
  if j <> 0 then do
   SetupKeys.i = strip(substr(Zeile,1,j-1),'B')
   SetupStrings.i = strip(substr(Zeile,j+1),'B')
  end
  else do
   SetupKeys.i = strip(Zeile,'B')
   SetupStrings.i = ''
  end
 end
 ok = lineout(SetupDatei)
 SetupKeys.0 = i
 SetupStrings.0 = i

return

/*:VRX         SetLanguage
*/
SetLanguage: 
  workingdirectory = VRGet( "Application", "WorkingDirectory" )
  ok = VRFileExists( workingdirectory"\lang.txt" )
  if ok = 1 then do
    call ReadSetup 'lang.txt'
    ok = VRSet( "DT_7", "Caption", SetupVar("DVD name") )

  end
return

/*:VRX         Settings_Close
*/
Settings_Close: 
    call Settings_Fini
return

/*:VRX         Settings_Create
*/
Settings_Create: 
    call Settings_Init
    ok = VRSet( "EF_ffmpegpath", "Value", ffmpegpath )
    ok = VRSet( "EF_ffmpegPar1", "Value", ffmpegpar1 )
    ok = VRSet( "EF_ffmpegPar2", "Value", ffmpegpar2 )
    ok = VRSet( "EF_bitrate", Value, ffmpegrate )
    ok = VRSet( "EF_aurate", Value, ffmpegaurate )
    ok = VRSet( "EF_dvdauthorpath", "Value", dvdauthorpath )
    ok = VRSet( "EF_dvdauthorParVOB", "Value", dvdauthorparVOB )
    ok = VRSet( "EF_dvdauthorParTOC", "Value", dvdauthorparTOC )
    ok = VRSet( "EF_mkisofs2path", "Value", mkisofs2path )
    ok = VRSet( "EF_mkisofs2Par", "Value", mkisofs2par )
    ok = VRSet( "EF_dvddaopath", "Value", dvddaopath )
    ok = VRSet( "EF_dvddaoPar", "Value", dvddaopar )
    ok = VRSet( "EF_dvddevice", "Value", dvddevice )
    ok = VRSet( "EF_structurepath", "Value", structpath )
    ok = VRSet( "CB_Interlace", "Set", ffmpeginterlace )
    ok = VRSet( "CB_DeInterlace", "Set", ffmpegdeinterlace )
    ok = VRSet( "CB_2PassEncode", "Set", ffmpeg2pass )
    call CB_2PassEncode_Click
return

/*:VRX         Settings_Fini
*/
Settings_Fini: 
    window = VRInfo( "Window" )
    call VRDestroy window
    drop window
return
/*:VRX         Settings_Init
*/
Settings_Init: 
    window = VRInfo( "Object" )
    if( \VRIsChildOf( window, "Notebook" ) ) then do
        call VRMethod window, "CenterWindow"
        call VRSet window, "Visible", 1
        call VRMethod window, "Activate"
    end
    drop window
return

/*:VRX         SetupVar
*/
SetupVar: 
 Key = ARG(1)
 Inhalt = ARG(2)
 gef = 0
 j = 0
 do i = 1 to SetupKeys.0
  if gef <> 1 then do
   if pos(translate(Key), translate(SetupKeys.i)) == 1 then do
    if Inhalt <> '' then do
     if translate(Inhalt) = '/L' then do
      SetupStrings.i = ''
      SetupKeys.i = '--/L--'
      j = j+1
     end
     else SetupStrings.i = Inhalt
    end
    gef = 1
    Ergebnis = strip( SetupStrings.i, 'B' )
   end
  end
 end
 Anzahl = SetupKeys.0+1-j
 SetupKeys.0 = Anzahl
 SetupStrings.0 = Anzahl
 if gef == 0 then do
  SetupKeys.Anzahl = Key
  SetupStrings.Anzahl = Inhalt
  Ergebnis = strip( SetupStrings.Anzahl, 'B' )
 end

return Ergebnis
